Package edu.wisc.game.parser

## Class Expression.MapTo<T>

- java.lang.Object
- - java.util.AbstractMap<K,​V>
  - - java.util.HashMap<String,​HashSet<T>>
    - - edu.wisc.game.parser.Expression.MapTo<T>

- All Implemented Interfaces:
    `Serializable`, `Cloneable`, `Map<String,​HashSet<T>>`
  Direct Known Subclasses:
    `Expression.VarMap`, `Expression.VarMap2`
  Enclosing interface:
    Expression

      public static class Expression.MapTo<T>
      extends HashMap<String,​HashSet<T>>

  A HashMap storing a set of values of a given type T for each key
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class java.util.AbstractMap

      `AbstractMap.SimpleEntry<K extends Object,​V extends Object>, AbstractMap.SimpleImmutableEntry<K extends Object,​V extends Object>`

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `Map.Entry<K extends Object,​V extends Object>`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MapTo()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `addValue​(String key, T val)` | Adds a value to the list of values associated with a specified key
    `void` | `pu​(RuleSet.BucketSelector key, T k)` |
    `void` | `pu​(String key, T k)` |
    `void` | `putSet​(RuleSet.BucketSelector key, HashSet<T> h)` |
    `String` | `toString()` |

    - ### Methods inherited from class java.util.HashMap

      `clear, clone, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, entrySet, forEach, get, getOrDefault, isEmpty, keySet, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size, values`

    - ### Methods inherited from class java.util.AbstractMap

      `equals, hashCode`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `equals, hashCode`

- - ### Constructor Detail

    - #### MapTo

          public MapTo()

  - ### Method Detail

    - #### addValue

          public boolean addValue​(String key,
                                  T val)

      Adds a value to the list of values associated with a specified key

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractMap<String,​HashSet<T>>`

    - #### pu

          public void pu​(String key,
                         T k)

      Parameters:
        `key` - A variable name, such as "p", "pc", "ps", or "propName.propValue"

    - #### pu

          public void pu​(RuleSet.BucketSelector key,
                         T k)

    - #### putSet

          public void putSet​(RuleSet.BucketSelector key,
                             HashSet<T> h)